/***************************************************************************
 *   Copyright (C) 2005 by Pawel Nawrocki                                  *
 *   pnawrocki@interia.pl                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 #include <qpainter.h>
 #include <qpalette.h>
 #include <qtooltip.h>
 
 #include <klistview.h>
 #include <kmessagebox.h>
 
 class NetListViewItem : public KListViewItem
 {
 public:
     //NetListViewItem(KListView *parent) : KListViewItem(parent) {}
     //NetListViewItem(KListView *parent, KListViewItem *after) : KListViewItem(parent, after) {}
     //NetListViewItem(KListView *parent, KListViewItem *after, QString essid, QString mode) : KListViewItem(parent, after, essid, mode) {}
     NetListViewItem(KListView *parent, QString essid, QString chan, QString mode, int quality, bool enc) 
     : KListViewItem(parent, QString::null, QString::null, QString::null, QString::null, QString::null)
     {
     	mEssid = essid;
     	mChannel = chan;
     	mMode = mode;
     	mQuality = quality;
     	mEnc = enc;

     	mEssidColumn = 0;
     	mChanColumn = 1;
     	mModeColumn = 2;
     	mQualityColumn = 3;
     	mEncColumn = 4;
     }
     
     ~NetListViewItem() {}
     
     // accessors;

  private:
     virtual void paintCell (QPainter *p, const QColorGroup &cg, int column, int width, int alignment);
     virtual int width(const QFontMetrics &fm, const QListView *lv, int column) const;
     virtual QString key( int column, bool ascending ) const;

     QString mEssid;
     QString mChannel;
     QString mMode;
     int mQuality;
     bool mEnc;
     int mQualityColumn;
     int mEncColumn;
     int mModeColumn;
     int mChanColumn;
     int mEssidColumn;

};
