/***************************************************************************
 *   Copyright (C) 2005 by Pawe? Nawrocki                                  *
 *   pnawrocki@interia.pl                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "ui_confpaths.h"
#include "wlassistant.h"

#include <kurlrequester.h>
#include <qcursor.h>
#include <kapplication.h>
#include <kmessagebox.h>

ui_confPaths::ui_confPaths(QWidget* parent, const char* name, WFlags fl)
: confPaths(parent,name,fl)
{
}

ui_confPaths::~ui_confPaths()
{
}

/*$SPECIALIZATION$*/

bool notFound;

void ui_confPaths::detectDevices()
{
	QString tmp;
	bool notFound;
	notFound=0;
	
	KApplication::setOverrideCursor( QCursor(Qt::WaitCursor) );
	
	tmp = WirelessAssistant::getPath("bin/dhcpcd",1);
	if (tmp.isEmpty()) {
		tmp = WirelessAssistant::getPath("bin/dhclient",1);
	}
	if (tmp.isEmpty()) notFound=1;
	if (tmp!="DENIED") {
		kcfg_pathDhcp->setURL( tmp );
	
		tmp = WirelessAssistant::getPath("bin/ifconfig",1); if (tmp.isEmpty()) notFound=1;
		kcfg_pathIf->setURL( tmp );
	
		tmp = WirelessAssistant::getPath("bin/iwconfig",1); if (tmp.isEmpty()) notFound=1;
		kcfg_pathIw->setURL( tmp );
	
		tmp = WirelessAssistant::getPath("bin/iwlist"); if (tmp.isEmpty()) notFound=1;
		kcfg_pathIwl->setURL( tmp );
	}
	
	KApplication::restoreOverrideCursor();
	if (notFound) KMessageBox::error(0, "One or more of the executables could not be found!\nPlease install necessary packages!");	
}


#include "ui_confpaths.moc"

