/***************************************************************************
 *   Copyright (C) 2005 by Pawe? Nawrocki                                  *
 *   pnawrocki@interia.pl                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "ui_confwep.h"

#include <qvalidator.h>
#include <klineedit.h>
#include <keditlistbox.h>
#include <kpushbutton.h>
#include <kmessagebox.h>

ui_confWep::ui_confWep(QWidget* parent, const char* name, WFlags fl)
: confWep(parent,name,fl)
{
    QRegExp rx;
    rx.setPattern("[\\w- ]+:{2,2}(s:.+|[\\dABCDEFabcdef][\\d-ABCDEFabcdef: ]*)");
    QValidator* validator = new QRegExpValidator( rx, this );
    kcfg_wepKeys->lineEdit()->setValidator( validator );
    connect(kcfg_wepKeys->lineEdit(), SIGNAL(textChanged(const QString &)),
    		this, SLOT(validateInput(const QString &)));
}

ui_confWep::~ui_confWep()
{
}

/*$SPECIALIZATION$*/

void ui_confWep::validateInput(const QString & str)
{
    int i = 0;
    QString t = str;
    const QValidator* validator = kcfg_wepKeys->lineEdit()->validator();
    bool on = ( validator->validate( t, i ) == QValidator::Acceptable );
    kcfg_wepKeys->addButton()->setEnabled( on );
}

#include "ui_confwep.moc"

