/***************************************************************************
 *   Copyright (C) 2005 by Pawel Nawrocki                                  *
 *   pnawrocki@interia.pl                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "ui_wepselect.h"
#include "wlassistant.h"
#include "waconfig.h"

#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qvalidator.h>

#include <kcombobox.h>
#include <klineedit.h>


ui_wepSelect::ui_wepSelect(QWidget* parent, const char* name, bool modal, WFlags fl)
: wepSelect(parent,name, modal,fl)
{
	QRegExp rx;
	rx.setPattern("(s:.+|[\\dABCDEFabcdef][\\d-ABCDEFabcdef: ]*)");
	QValidator* validator = new QRegExpValidator( rx, this );
	lineCustom->setValidator( validator );
	
	QStringList wepList = WaSettings::wepKeys();
	comboKeys->clear();
	if (wepList.isEmpty()) { 
		lineCustom->setEnabled(1);
		lineCustom->setFocus();
		checkCustom->setEnabled(0);
		checkCustom->setChecked(1);
		comboKeys->insertItem("No WEP keys found! See configuration.");
		comboKeys->setEnabled(0);
	}
	else {
		int i = 1;
		while (!WirelessAssistant::getKey(i).isEmpty()) {
			comboKeys->insertItem( QString(WirelessAssistant::getKey(i,1) +	" (" + WirelessAssistant::getKey(i) + ")") );
			i++;
		}
	}
	if (WaSettings::defaultOpen()) radioOpen->setChecked(1);
	else radioRestricted->setChecked(1);
}

ui_wepSelect::~ui_wepSelect()
{
}

/*$SPECIALIZATION$*/
QString ui_wepSelect::getWKey()
{
	QString key = QString::null;
	if (checkCustom->isChecked()) {
		key = lineCustom->text();
	}
	else {
		key = WirelessAssistant::getVal(comboKeys->currentText()," (",")");
	}
	return key;
}

QString ui_wepSelect::getWepMode()
{
	QString mode = QString::null;
	if (radioOpen->isChecked()) mode = "open";
	else mode = "restricted";
	return mode;
}

void ui_wepSelect::reject()
{
  QDialog::reject();
}

void ui_wepSelect::accept()
{
  QDialog::accept();
}


#include "ui_wepselect.moc"

