/***************************************************************************
 *   Copyright (C) 2005 by Pawel Nawrocki                                  *
 *   pnawrocki@interia.pl                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WLASSISTANT_H
#define WLASSISTANT_H

#include "ui_main.h"
#include "waconfig.h"
//#include "netparams.h"

//#include <qprocess.h>
#include <qmutex.h>
#include <qlistbox.h>


class WirelessAssistant : public mainWindow
{
  Q_OBJECT

public:
/*$PUBLIC_FUNCTIONS$*/
  WirelessAssistant(QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~WirelessAssistant();

  static QString getPath(QString cmd, bool skipErr = 0);
  static QString getVal(QString str, QString start, QString end, QString sectDelimit = QString::null, int sectNo = 0, int offset = 0);

public slots:
  /*$PUBLIC_SLOTS$*/
    virtual void setDeviceList();
    virtual void netConnect();
    virtual void netScan();
    virtual void showCfgDlg();
    
    static QString getKey(int keyno, bool keyname = 0)
    {
    	QString key = QString::null;
    	QStringList wepList;
    	wepList = WaSettings::wepKeys();
    	int i = 0;
    		for ( QStringList::Iterator it = wepList.begin(); it != wepList.end(); it++ ) {
			if (i+1 < keyno) {i++; continue;}
			
			if (keyname) key = WirelessAssistant::getVal(*it,"","::");
			else key = WirelessAssistant::getVal(*it,"::","");
			
			break;
	}
	return key;
    }

protected:
  /*$PROTECTED_FUNCTIONS$*/
    //void setProc(QString cmd);
    void readConfig();
    void saveSettings();
    void showErr(int errNum);
    void setUi(int uiState);
    void setSuid();
    void setSingleClick(bool i);
    void clearDhcp();
    QString getIfName(QString ifName);
    QString getDev();
    QString getWepKey();
    QString runCommand( QString cmd, int errLevel = 1 );	//errLevel: 0 - no errors, 1 - only 'denied' errors, 2 - all errors
    bool connectionOk();

	bool startup;
	//bool masterToManaged;

protected slots:
  /*$PROTECTED_SLOTS$*/
    virtual void parseScan( QString output );
    virtual void parseDevDetect( QString output );
    virtual void uiScanned();
    virtual void uiConnected( bool ok );
    virtual void uiDevDetected();
    virtual void setNetListColumns();
    virtual void updateConfiguration();
};

#endif
